' CNC Host controller
' added RPG and Jog routines
' added file selection screen
' added Configuration menus
' added code to send configuration params to the 3 axis controllers
' changed code in the Linear and Rapid routines to correct bug in double -> integer conversion
' added code for E-Stop and limit switch status
' changed code in Waitexecution routine to correct timing error
' added axis invert definiton screen
' added configuration display screen
' removed all diagnostic printouts to monitor port
' added code to cancel the fault line output( i.e. return it to high) when going back to manual menu, and
' also when returning to the g-code run menu

$regfile = "M1284Pdef.dat"
$crystal = 20000000
$hwstack = 200
$swstack = 200
$framesize = 200

Dim Btemp1 As Byte
Dim Tapfiles(64) As String * 8
Dim S As String * 16
Dim T As String * 60
Dim Cmdstring As String * 255
Dim Perstring As String * 255
Dim Paramstr As String * 12
Dim R As String * 1
Dim Js As String * 2
Dim I As Byte
Dim Numtaps As Byte
Dim Zz As Byte
Dim K As Word
Dim J As Word
Dim Cmdptr As Byte
Dim Cmdlen As Byte
Dim Pflag As Boolean
Dim Eolflag As Boolean
Dim Eopflag As Boolean
Dim Motionflag As Boolean
Dim Limitswitch As Boolean
Dim Reincrflag As Boolean
Dim Rechangeflag As Boolean
Dim Sivalidflag As Boolean
Dim Rrvalidflag As Boolean
Dim Rampvalidflag As Boolean
Dim Abortflag As Boolean
Dim Pauseflag As Boolean
Dim Estop As Boolean
Dim Xaxisinvert As Boolean
Dim Yaxisinvert As Boolean
Dim Zaxisinvert As Boolean
Dim Rapidflag As Boolean
Dim Stemp As Single
Dim Dtemp As Double
Dim Feedrate As Single
Dim Feedratex As Single
Dim Feedratey As Single
Dim Feedratez As Single
Dim Frratio As Double
Dim Targetx As Double
Dim Targety As Double
Dim Targetz As Double
Dim Currentx As Double
Dim Currenty As Double
Dim Currentz As Double
Dim Xtemp As Double
Dim Ytemp As Double
Dim Ztemp As Double
Dim Xtemp1 As Double
Dim Ytemp1 As Double
Dim Ztemp1 As Double
Dim Sdtemp As Single
Dim Xdisplacement As Integer                                ' Displacements Are In Mils(1 / 1000 ")"
Dim Ydisplacement As Long
Dim Zdisplacement As Long
Dim Stepsperinch As Single
Dim Gomode As Integer
Dim Mmode As Integer
Dim Ltemp As Long
Dim Pulserate As Single
Dim Pulseratex As Single
Dim Pulseratey As Single
Dim Pulseratez As Single
Dim Rapidrate As Single
Dim Ramprate As Single
Dim Tick As Integer
Dim Ltemp1 As Double
Dim Ltemp2 As Double
Dim Fracdiv As Word
Dim Rate As Double
Dim Retemp As Byte
Dim Rpgaxisid As Byte
Dim Rpgcount As Single
Dim Hs As Byte
Dim Jogstatus As Byte
Dim Tstemp As Long
Dim Lastjog As Byte
Dim Nvstepsperinch As Eram Single
Dim Nvrapidrate As Eram Single
Dim Nvramprate As Eram Single
Dim Nvrpgcount As Eram Single
Dim Nvsivalidflag As Eram Byte
Dim Nvrapidvalidflag As Eram Byte
Dim Nvrampvalidflag As Eram Byte
Dim Nvrpgvalidflag As Eram Byte
Dim Nvaxisinvert As Eram Byte

' LCD touchscreen vars
Dim Keypad(12) As String * 1
Dim Numstr As String * 32
Dim Touchx As Integer
Dim Touchy As Integer
Dim Msb As Byte
Dim Lsb As Byte
Dim Keycol As Byte
Dim Keyrow As Byte
Dim Keyerr As Boolean
Dim Delkey As Boolean
Dim Strlen As Byte
Dim Strtemp As Single
Dim Ch As Byte
Dim Keynum As Byte
Dim Temp As Byte
Dim Lcdx As Word
Dim Lcdy As Word
Dim Lcdrow As Byte
Dim Lcdcol As Byte
Dim Collsb As Byte
Dim Colmsb As Byte
Dim Textcolourlsb As Byte
Dim Textcolourmsb As Byte
Dim Filenameindex As Byte
Dim Fstart As Byte
Dim Fend As Byte

Declare Sub Skipspace()
Declare Sub Feedparam()
Declare Sub Gparam()
Declare Sub Sparam()
Declare Sub Xparam()
Declare Sub Yparam()
Declare Sub Zparam()
Declare Sub Mparam()
Declare Sub Getnumeric()
Declare Sub Parseerror()
Declare Sub Getcurrentx()
Declare Sub Getcurrenty()
Declare Sub Getcurrentz()
Declare Sub Spindleoff()
Declare Sub Nparam()
Declare Sub Rapid()
Declare Sub Linear()
Declare Sub Circularcw()
Declare Sub Circularccw()
Declare Sub Comment()
Declare Sub Checkrpg()
Declare Sub Manualpodmode()
Declare Sub Loadgcodemode()
Declare Sub Getfirstlineoffile()
Declare Sub Configurationmode()
Declare Function Menu1selection() As Byte
Declare Function Menu2selection() As Byte
Declare Function Menu3selection() As Byte
Declare Sub Configstepsperinch()
Declare Sub Configrapidrate()
Declare Sub Configramprate()
Declare Sub Configrpgcount()
Declare Sub Configdirection()
Declare Sub Macro1()
Declare Sub Macro2()
Declare Sub Macro3()
Declare Sub Macro4()
Declare Sub Macro5()
Declare Sub Macro6()
Declare Sub Getnvaxisinvert()
Declare Sub Displayparams()
Declare Function Getnumber() As Single
Declare Function Checkhome() As Byte
Declare Function Checkmotor1sw()as Byte

' LCD touchscreen routines
Declare Function Ulcdwait() As Byte
Declare Sub Gettouch(byval Mode As Byte)
Declare Sub Drawkeypad()
Declare Function Getkey() As Byte
Declare Sub Initulcd32()
Declare Sub Lcdprintch(ch As Byte)
Declare Sub Lcdprintstring(byval Row As Byte , Byval Col As Byte)
Declare Sub Drawjogpad()
Declare Function Getjogpod() As Byte
Declare Sub Drawfilescreen()
Declare Function Getfileselect() As Byte
Declare Sub Drawmenu1()
Declare Sub Drawmenu2()
Declare Sub Drawmenu3()
Declare Sub Waitforexecution()
Declare Sub Lcddrawcircle()

Const True = 1
Const False = 0

Const Xid = 129                                             ' ID number of X channel
Const Yid = 130                                             ' ID # of Y channel
Const Zid = 131                                             ' ID # of Z channel
Const Aid = 132                                             ' Id # of Aux channel

Keypad(1) = "1"
Keypad(2) = "2"
Keypad(3) = "3"
Keypad(4) = "4"
Keypad(5) = "5"
Keypad(6) = "6"
Keypad(7) = "7"
Keypad(8) = "8"
Keypad(9) = "9"
Keypad(10) = "."
Keypad(11) = "0"
Keypad(12) = "E"

'$include "Config_MMC_M1284.bas"
$include "Config_MMCSD_HC.bas"                              'you need this vers of library if you are using SDHC cards

' Configure the I/O port pins

Config Porta.0 = Input
Doneflag Alias Pina.0

Config Porta.1 = Input
Set Porta.1
Rpgxswitch Alias Pina.1

Config Porta.2 = Input
Set Porta.2
Rpgyswitch Alias Pina.2

Config Porta.3 = Input
Set Porta.3
Rpgzswitch Alias Pina.3

Config Porta.4 = Input
Set Porta.4
Rpgaswitch Alias Pina.4

Config Porta.5 = Output
Set Porta.5
Faultled Alias Porta.5

Config Porta.7 = Input
Set Porta.7                                                 ' configure pull-up on SD card detect line
Sdcarddetect Alias Pina.7

Config Portb.1 = Output
Nfaultout Alias Portb.1
Set Portb.1

Config Portb.2 = Output
Nexecute Alias Portb.2
Set Nexecute

Config Portc.0 = Input
Estopswitch Alias Pinc.0
Set Portc.0                                                 ' enable pull-up on estop pin

Config Portc.1 = Output
Motor1 Alias Portc.1
Reset Motor1

Config Portc.4 = Input
Motor1sw Alias Pinc.4
Set Portc.4                                                 ' enable pull-up on spindle motor on/off switch

Config Portc.5 = Input
Set Portc.5
Homeswitch Alias Pinc.5

Config Portc.6 = Input
Set Portc.6                                                 ' enable pull up on RE A line

Config Portc.7 = Input
Set Portc.7                                                 ' enable pull up on RE B line

Config Portd.4 = Input
Limitswitchin Alias Pind.4
Set Portd.4                                                 ' enable a pull-up on *Fault in




' Initialize the uLCD32 LCD touchscreen serial port
$baud = 9600
Open "Com1:9600,8,n,1" For Binary As #1

' initialize the serial link to the Mega88 Axis controllers
$baud1 = 38400
Open "Com2:38400,8,n,1" For Binary As #2

' initialize a software UART for use as a console debug port
Open "coma.6:9600,8,n,2" For Output As #3                   'console port on PortA.6

Wait 2                                                      ' need a second or 2 for uthe uLCD to be ready (dependent upon size/presence of SD card)

' Print #3 , "CNC Controller C 2012 Brian Millier"

Call Initulcd32()
Wait 1

Enable Interrupts

' set up timer 0 as 500 hz clock- fed to CNC axis controllers to refresh LED display
Tccr0a = &B01000010                                         ' CTC mode, toggle OC2A on match
Tccr0b = &B00000100                                         ' CLK /256
Ocr0a = 77
Timsk0 = &B00000010                                         ' enable compare match A interrupt
On Compare0a 500hzisr
Config Portb.3 = Output                                     ' 500 Hz LED refresh clock output


' set up timer 2 as 10 KHZ Charge pump output for Gecko drive
Tccr2a = &B01000010                                         ' CTC mode, toggle OC2A on match
Tccr2b = &B00000010                                         ' CLK /8
Ocr2a = 124
Config Portd.7 = Output

Limitswitch = False
Stepsperinch = 20000.0
Rapidrate = 30000.0
Eopflag = False


' load current parameters from NV memory
Ramprate = Nvramprate
Rpgcount = Nvrpgcount
Stepsperinch = Nvstepsperinch
Rapidrate = Nvrapidrate

Call Getnvaxisinvert()                                      ' get axis invert status from EEPROM


' send current parameters to all axis controllers
For I = Xid To Zid
  Print #2 , Chr(i);
  Print #2 , "R";
  T = Fusing(ramprate , "####.")
  Print #2 , T
Next
' Print #3 , "Ramprate " ; Ramprate
Waitms 50
For I = Xid To Zid
  Print #2 , Chr(i);
  Print #2 , "P";
  T = Fusing(rpgcount , "#####.")
  Print #2 , T
Next
' Print #3 , "RPGcount " ; Rpgcount
Waitms 50
For I = Xid To Zid
  Print #2 , Chr(i);
  Print #2 , "X";
  Print #2 , Stepsperinch
Next
' Print #3 , "steps per inch " ; Stepsperinch
' Print #3 , "Rapid  Rate " ; Rapidrate

Estop = False
Limitswitch = False
Set Faultled                                                ' turn off fault LED

' Main program command loop

Do
 Call Drawmenu1()
 ' check limit and E-stop status
 If Estopswitch = 0 Then
  Estop = True
  Reset Faultled
  Print "O";                                                'non transparent text- allows erasure
  Print Chr(1);
  Temp = Ulcdwait()
  Lcdrow = 15
  Lcdcol = 1
  ' set text colour to light red
  Textcolourmsb = &B11111100
  Textcolourlsb = &B00010000
  T = "E-STOP"
  Call Lcdprintstring(lcdrow , Lcdcol)
 End If
 If Limitswitchin = 1 Then
  Limitswitch = True
  Reset Faultled
  Print "O";                                                'non transparent text- allows erasure
  Print Chr(1);
  Temp = Ulcdwait()
  Lcdrow = 16
  Lcdcol = 1
  ' set text colour to light red
  Textcolourmsb = &B11111100
  Textcolourlsb = &B00010000
  T = "LIMIT"
  Call Lcdprintstring(lcdrow , Lcdcol)
 End If
 Do
  If Estopswitch = 1 Then
     Estop = False
     Print "O";                                             'non transparent text- allows erasure
     Print Chr(1);
     Temp = Ulcdwait()
     Lcdrow = 15
     Lcdcol = 1
    ' set text colour to light red
     Textcolourmsb = &B11111100
     Textcolourlsb = &B00010000
     T = "      "
     Call Lcdprintstring(lcdrow , Lcdcol)
  End If
  If Limitswitchin = 0 Then
     Limitswitch = False
     Print "O";                                             'non transparent text- allows erasure
     Print Chr(1);
     Temp = Ulcdwait()
     Lcdrow = 16
     Lcdcol = 1
    ' set text colour to light red
     Textcolourmsb = &B11111100
     Textcolourlsb = &B00010000
     T = "      "
     Call Lcdprintstring(lcdrow , Lcdcol)
   End If
  If Limitswitch = False Then
      If Estop = False Then
       Set Faultled
       Exit Do
      End If
  End If
 Loop
 Temp = Menu1selection()
 Select Case Temp
  Case Is = 0 : Call Manualpodmode
  Case Is = 1 : Call Loadgcodemode
  Case Is = 2 : Call Configurationmode
  Case Is = 3 : Call Displayparams()
 End Select
 Waitms 250
Loop

Sub Displayparams()
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
' set text colour to white
 Textcolourmsb = 127
 Textcolourlsb = 63
 T = "Steps/inch= " + Str(stepsperinch)
 Lcdrow = 0
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
 T = "Rapid rate= "
 T = T + Fusing(rapidrate , "###.##")
 Lcdrow = 1
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
 T = "Ramp rate= "
 T = T + Fusing(ramprate , "###.")
 Lcdrow = 2
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
 T = "RPG steps= "
 T = T + Fusing(rpgcount , "####.")
 Lcdrow = 3
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
 If Xaxisinvert = True Then
  T = "X Axis Inverted"
 Else
  T = "X Axis Normal"
 End If
 Lcdrow = 4
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
 If Yaxisinvert = True Then
  T = "Y Axis Inverted"
 Else
  T = "Y Axis Normal"
 End If
 Lcdrow = 5
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
 If Zaxisinvert = True Then
  T = "Z Axis Inverted"
 Else
  T = "Z Axis Normal"
 End If
 Lcdrow = 6
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
 Do
  Hs = Checkhome()
  If Hs = 1 Then Exit Do
 Loop
End Sub



Sub Manualpodmode()
 Set Nfaultout                                              ' clear fault line to axis controllers
 Call Drawjogpad()
 If Estopswitch = 1 Then Set Faultled
 If Limitswitch = 0 Then Set Faultled
 ' place an OK status display
 Print "O";                                                 'non transparent text- allows erasure
 Print Chr(1);
 Temp = Ulcdwait()
 Lcdrow = 1
 Lcdcol = 13
 ' set text colour to light green
 Textcolourmsb = 7
 Textcolourlsb = &HE0
 T = "  OK  "
 Call Lcdprintstring(lcdrow , Lcdcol)
 Lastjog = 0
 Rechangeflag = False
 Do
  Hs = Checkmotor1sw()                                      ' poll spindle drive on/off switch
  Hs = Checkhome()
  If Hs = 1 Then Exit Do
  Call Checkrpg()
  Jogstatus = Getjogpod()
  If Jogstatus <> Lastjog Then
    If Jogstatus = 0 Then
     Set Nexecute
     Lastjog = 0
    Else
     If Jogstatus < 255 Then
      Lastjog = Jogstatus
     End If
    End If
  End If
 Loop
End Sub

Function Checkhome()
 Checkhome = 0
  If Homeswitch = 0 Then
   Waitms 50                                                ' debounce the switch
   If Homeswitch = 0 Then
    Print "E";                                              ' clear the touch screen
    Temp = Ulcdwait()
    Bitwait Homeswitch , Set                                ' wait til home switch is released
    Checkhome = 1
   End If
  End If
End Function

Function Checkmotor1sw()
 If Motor1sw = 0 Then
  Set Motor1
 Else
  Reset Motor1
 End If
End Function

Sub Loadgcodemode()
  Set Nfaultout                                             ' clear fault line to axis controllers
' ' Print #3 , "Waiting for SD Card"
 If Sdcarddetect = 1 Then                                   ' no SD card in place
   ' clear the screen
   Print "E";
   Temp = Ulcdwait()
   T = "SD Card not found"
   Lcdrow = 1
   Lcdcol = 1
   ' set colour to white
   Textcolourmsb = 255
   Textcolourlsb = 255
   Call Lcdprintstring(lcdrow , Lcdcol)
   Lcdrow = 3
   T = "Power down & insert card"
   Call Lcdprintstring(lcdrow , Lcdcol)
   For I = 1 To 250
     Hs = Checkhome()
     If Hs = 1 Then Exit For
     Waitms 25
   Next
   Exit Sub
  End If
 If Gbdriveerror = 0 Then
   ' Include AVR-DOS Configuration and library
  $include "Config_AVR-DOS.BAS"
  ' Print #3 , "Initializing File System ... "
  Btemp1 = Initfilesystem(1)                                ' Partition 1
  If Btemp1 <> 0 Then
     ' Print #3 , "Error: " ; Btemp1 ; " during Init file system"
  Else
     ' Print #3 , " OK"
  End If
 Else
   ' Print #3 , "Error during Drive Init: " ; Gbdriveerror
 End If

Call Drawfilescreen()
' load up to 64 CNC files ( with .TAP extension )
 I = 1
 S = Dir( "*.tap")
 While Len(s) > 0                                           ' if there was a file found
   J = Instr(1 , S , ".")
   Decr J
   T = Left(s , J)
   Tapfiles(i) = T
   ' Print #3 , T
   Incr I
   If I > 64 Then Exit While
   S = Dir()                                                ' get next
 Wend
 Decr I
 Numtaps = I
 ' Print #3 , "# of files" ; "  " ; Numtaps

 ' display list of first 16 .TAP files
 Lcdrow = 1
 Lcdcol = 1
 Filenameindex = 1
 ' set highlighted filename colour to light green
 Textcolourmsb = 7
 Textcolourlsb = &HE0
 T = Tapfiles(filenameindex)
 Call Lcdprintstring(lcdrow , Lcdcol)
 Incr Lcdrow
 'set all other filenames to a white colour
 Textcolourmsb = 255
 Textcolourlsb = 255
 For Zz = 2 To 16
  If Zz > Numtaps Then
   T = "        "
  Else
   T = Tapfiles(zz)
  End If
  Call Lcdprintstring(lcdrow , Lcdcol)
  Incr Lcdrow
 Next
 Filenameindex = 1
 Call Getfirstlineoffile()
 Lcdrow = 1

 ' CNC file selection loop
Do
 Hs = Checkhome()
 If Hs = 1 Then Exit Do
 I = Getfileselect()
 If I = 1 Then
  If Lcdrow > 1 Then
    ' re-draw currently highlighted filename to white
    Textcolourmsb = 255
    Textcolourlsb = 255
    T = Tapfiles(filenameindex)
    Call Lcdprintstring(lcdrow , Lcdcol)
    ' move to previous filename, and highlight it
    Decr Filenameindex
    Decr Lcdrow
    Textcolourmsb = 7
    Textcolourlsb = &HE0
    T = Tapfiles(filenameindex)
    Call Lcdprintstring(lcdrow , Lcdcol)
    Call Getfirstlineoffile()
  Else
   If Filenameindex > 16 Then
   ' switch to the previous page of filmnames
    Call Drawfilescreen()                                   ' clear the page
    Lcdrow = 1
    Lcdcol = 1
    Filenameindex = Filenameindex - 16
    'set filenames to a white colour
    Textcolourmsb = 255
    Textcolourlsb = 255
    Fstart = Filenameindex
    Fend = Filenameindex + 14
    For Zz = Fstart To Fend
     If Zz > Numtaps Then
      T = "        "
     Else
      T = Tapfiles(zz)
     End If
     Call Lcdprintstring(lcdrow , Lcdcol)
     Incr Lcdrow
    Next
    ' set highlighted filename colour to light green
    Textcolourmsb = 7
    Textcolourlsb = &HE0
    Lcdrow = 16
    Filenameindex = Fend + 1
    T = Tapfiles(filenameindex)
    Call Lcdprintstring(lcdrow , Lcdcol)
    Call Getfirstlineoffile()
   End If
  End If
 Waitms 100
 End If
If I = 2 Then
  If Lcdrow < 16 Then
    ' re-draw currently highlighted filename to white
    Textcolourmsb = 255
    Textcolourlsb = 255
    T = Tapfiles(filenameindex)
    Call Lcdprintstring(lcdrow , Lcdcol)
    ' move to next filename, and highlight it
    Incr Filenameindex
    Incr Lcdrow
    Textcolourmsb = 7
    Textcolourlsb = &HE0
    T = Tapfiles(filenameindex)
    Call Lcdprintstring(lcdrow , Lcdcol)
    Call Getfirstlineoffile()
  Else
   ' switch to the next page of filenames
   Call Drawfilescreen()                                    ' clear the page
   Lcdrow = 1
   Lcdcol = 1
   Incr Filenameindex
   ' set highlighted filename colour to light green
   Textcolourmsb = 7
   Textcolourlsb = &HE0
   T = Tapfiles(filenameindex)
   Call Lcdprintstring(lcdrow , Lcdcol)
   Incr Lcdrow
   'set all other filenames to a white colour
   Textcolourmsb = 255
   Textcolourlsb = 255
   Fstart = Filenameindex + 1
   Fend = Filenameindex + 15
   For Zz = Fstart To Fend
    If Zz > Numtaps Then
     T = "        "
    Else
     T = Tapfiles(zz)
    End If
    Call Lcdprintstring(lcdrow , Lcdcol)
    Incr Lcdrow
   Next
   Lcdrow = 1
   Call Getfirstlineoffile()
  End If
 Waitms 100
 End If
If I = 3 Then Exit Do
Loop

If Hs = 1 Then Exit Sub                                     ' home switch pushed

 ' form the full filename of the file chosen
 S = Tapfiles(filenameindex)
 T = S + ".tap"
 S = T                                                      ' save filename for later use in opening/accessing file
' CNC File selected- put up the G-Code execution screen

 Call Drawmenu2()

 ' place an OK status display
 Print "O";                                                 'non transparent text- allows erasure
 Print Chr(1);
 Temp = Ulcdwait()
 Lcdrow = 1
 Lcdcol = 13
 ' set text colour to light green
 Textcolourmsb = 7
 Textcolourlsb = &HE0
 T = "  OK  "
 Call Lcdprintstring(lcdrow , Lcdcol)

 If Estopswitch = 0 Then
  Estop = True
  Reset Faultled
  Lcdrow = 1
  Lcdcol = 13
  ' set text colour to light red
  Textcolourmsb = &B11111100
  Textcolourlsb = &B00010000
  T = "E-STOP"
  Call Lcdprintstring(lcdrow , Lcdcol)
 End If
 If Limitswitchin = 1 Then
  Limitswitch = True
  Reset Faultled
  Lcdrow = 2
  Lcdcol = 13
  ' set text colour to light red
  Textcolourmsb = &B11111100
  Textcolourlsb = &B00010000
  T = "LIMIT"
  Call Lcdprintstring(lcdrow , Lcdcol)
 End If

 ' wait until the start button is pressed
Do
 Hs = Checkhome()
 If Hs = 1 Then Exit Do
 Temp = Menu2selection()
Loop Until Temp = 0

If Hs = 1 Then Exit Sub                                     ' home switch pushed

Cncprogramstart:
 Hs = 0                                                     ' need this line

 'set transparency off so text can erase older text under it
 Print "O";
 Print Chr(1);
 Temp = Ulcdwait()
 ' set text colour to light green
 Lcdrow = 0
 Lcdcol = 13
 Textcolourmsb = 7
 Textcolourlsb = &HE0
 T = "  RUN"
 Call Lcdprintstring(lcdrow , Lcdcol)
 Lcdrow = 1
 Lcdcol = 13
 T = " OK   "
 Call Lcdprintstring(lcdrow , Lcdcol)

 Call Getcurrentx()
 Call Getcurrenty()
 Call Getcurrentz()

' READ G Code FILE

Open S For Input As #10
Abortflag = False
Pauseflag = False
While Eof(10) = 0
 Lineinput #10 , Cmdstring
' display the G-code line on the touchscreen
 Textcolourmsb = 255                                        ' light blue
 Textcolourlsb = 255
 T = Space(60)
 Lcdrow = 15
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
 T = Left(cmdstring , 60)
 Lcdrow = 15
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
 Cmdlen = Len(cmdstring)
 Cmdptr = 1
 Eolflag = False
 Motionflag = False
 While Eolflag = False
   Call Skipspace
   If Eolflag = True Then Exit While
   Select Case R
    Case "F" : Call Feedparam
    Case "G" : Call Gparam
    Case "M" : Call Mparam
    Case "N" : Call Nparam
    Case "S" : Call Sparam
    Case "X" : Call Xparam
    Case "Y" : Call Yparam
    Case "Z" : Call Zparam
    Case ";" : Call Comment
    Case Else : Call Parseerror()
   End Select
 Wend
 ' A complete command line has been parsed- so act upon it
 ' check motion flag to see if axis motion is needed
 If Motionflag = True Then
   Select Case Gomode
    Case Is = 0 : Call Rapid
    Case Is = 1 : Call Linear
    Case Is = 2 : Call Circularcw
    Case Is = 3 : Call Circularccw
   End Select
 End If
 If Abortflag = True Then Exit While                        ' STOP button pressed on touchscreen
 If Limitswitch = True Then Exit While
 If Estop = True Then Exit While
 Hs = 0
 If Pauseflag = True Then
  ' set text colour to light green
  Textcolourmsb = 7
  Textcolourlsb = &HE0
  Lcdrow = 0
  Lcdcol = 13
  T = "PAUSE"
  Call Lcdprintstring(lcdrow , Lcdcol)

 'wait until CONTINUE button pushed on T screen
  Do
    Hs = Checkhome()                                        ' also check for the home button pressed
    If Hs = 1 Then Exit Do
    Temp = Menu2selection()
    If Temp = 2 Then                                        ' CONTINUE switch pressed
     Pauseflag = False
     Lcdrow = 0
     Lcdcol = 13
     Textcolourmsb = 7
     Textcolourlsb = &HE0
     T = "RUN   "
     Call Lcdprintstring(lcdrow , Lcdcol)
      Exit Do
    End If
  Loop
 End If
 If Hs = 1 Then Exit While
Wend
Close #10
If Hs = 1 Then Exit Sub
' Print #3 , "CNC program end"
Textcolourmsb = 7
Textcolourlsb = &HE0
Lcdrow = 0
Lcdcol = 13
T = "ENDED"
If Abortflag = True Then T = "ABORT"
If Limitswitch = True Then T = "ABORT"
Call Lcdprintstring(lcdrow , Lcdcol)
Do
 If Limitswitchin = 0 Then
  If Limitswitch = True Then
   Limitswitch = False
   Print "O";                                               'non transparent text- allows erasure
   Print Chr(1);
   Temp = Ulcdwait()
   Lcdrow = 1
   Lcdcol = 13
 ' set text colour to light green
   Textcolourmsb = 7
   Textcolourlsb = &HE0
   T = "  OK  "
   Call Lcdprintstring(lcdrow , Lcdcol)
   End If
 End If
 If Estopswitch = 1 Then
  If Estop = True Then
   Estop = False
   Print "O";                                               'non transparent text- allows erasure
   Print Chr(1);
   Temp = Ulcdwait()
   Lcdrow = 1
   Lcdcol = 13
 ' set text colour to light green
   Textcolourmsb = 7
   Textcolourlsb = &HE0
   T = "  OK  "
   Call Lcdprintstring(lcdrow , Lcdcol)
   End If
 End If


 Hs = Checkhome()
Loop Until Hs = 1
End Sub

Function Menu1selection() As Byte
 Keyerr = False
 Call Gettouch(1)
 Select Case Touchy
  Case 0 To 30 : Menu1selection = 0
  Case 40 To 70 : Menu1selection = 1
  Case 90 To 120 : Menu1selection = 2
  Case 140 To 170 : Menu1selection = 3
  Case Else : Keyerr = True
 End Select
 If Keyerr = True Then
   Menu1selection = 255
 End If
 Call Gettouch(2)
End Function

Function Menu2selection() As Byte
 Keyerr = False
 ' first check to see if touchpad is pressed
 Print "o";
 Print Chr(4);
 Inputbin Tstemp
 If Tstemp = 0 Then
  Menu2selection = 255                                      ' touchpad is not pressed - exit function
  Exit Function
 End If
 Call Gettouch(5)
 Select Case Touchy
  Case 0 To 30 : Menu2selection = 0
  Case 40 To 70 : Menu2selection = 1
  Case 90 To 120 : Menu2selection = 2
  Case 140 To 170 : Menu2selection = 3
  Case Else : Keyerr = True
 End Select
 If Keyerr = True Then
   Menu2selection = 255
 End If
End Function

Function Menu3selection() As Byte
 Keyerr = False
 ' first check to see if touchpad is pressed
 Print "o";
 Print Chr(4);
 Inputbin Tstemp
 If Tstemp = 0 Then
  Menu3selection = 255                                      ' touchpad is not pressed - exit function
  Exit Function
 End If
 Call Gettouch(5)
 Select Case Touchy
  Case 0 To 30 : Menu3selection = 0
  Case 40 To 70 : Menu3selection = 1
  Case 90 To 120 : Menu3selection = 2
  Case 140 To 170 : Menu3selection = 3
  Case 190 To 220 : Menu3selection = 4
  Case Else : Keyerr = True
 End Select
 If Keyerr = True Then
   Menu3selection = 255
 End If
 Call Gettouch(2)
End Function


' Draw Main program menu
Sub Drawmenu1()
 Keynum = 0
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
  ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 ' Set transparent Text so button text can be seen
 Print "O";
 Print Chr(0);
 Temp = Ulcdwait()
 For Lcdy = 0 To 150 Step 50
 Lcdx = 10
   Print "b";
   Print Chr(1);
   Temp = High(lcdx)
   Print Chr(temp);
   Temp = Low(lcdx)
   Print Chr(temp);
   Temp = High(lcdy)
   Print Chr(temp);
   Temp = Low(lcdy)
   Print Chr(temp);
   Print Chr(127);                                          'color
   Print Chr(63);                                           'color
   Print Chr(0);                                            'small font needed
   Print Chr(0);
   Print Chr(0);
   Print Chr(2);
   Print Chr(2);
   Numstr = Lookupstr(keynum , Menu1table)
   Print Numstr;
   Print Chr(0);
   Incr Keynum
   Temp = Ulcdwait()
 Next
End Sub


' Draw G-Code Execution sub-menu
Sub Drawmenu2()
 Keynum = 0
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
  ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 ' Set transparent Text so button text can be seen
 Print "O";
 Print Chr(0);
 Temp = Ulcdwait()
 For Lcdy = 0 To 150 Step 50
   Lcdx = 10
   Print "b";
   Print Chr(1);
   Temp = High(lcdx)
   Print Chr(temp);
   Temp = Low(lcdx)
   Print Chr(temp);
   Temp = High(lcdy)
   Print Chr(temp);
   Temp = Low(lcdy)
   Print Chr(temp);
   Print Chr(127);                                          'color
   Print Chr(63);                                           'color
   Print Chr(0);                                            'small font needed
   Print Chr(0);
   Print Chr(0);
   Print Chr(2);
   Print Chr(2);
   Numstr = Lookupstr(keynum , Menu2table)
   Print Numstr;
   Print Chr(0);
   Incr Keynum
   Temp = Ulcdwait()
 Next
 ' display the filename at bottom of screen
 Textcolourmsb = &B10000100                                 ' light blue
 Textcolourlsb = &B00011111
 Lcdrow = 19
 Lcdcol = 0
 Call Lcdprintstring(lcdrow , Lcdcol)
End Sub

'Draw Configuration sub menu
Sub Drawmenu3()
 Keynum = 0
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
  ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 ' Set transparent Text so button text can be seen
 Print "O";
 Print Chr(0);
 Temp = Ulcdwait()
 For Lcdy = 0 To 200 Step 50
 Lcdx = 10
   Print "b";
   Print Chr(1);
   Temp = High(lcdx)
   Print Chr(temp);
   Temp = Low(lcdx)
   Print Chr(temp);
   Temp = High(lcdy)
   Print Chr(temp);
   Temp = Low(lcdy)
   Print Chr(temp);
   Print Chr(127);                                          'color
   Print Chr(63);                                           'color
   Print Chr(0);                                            'small font needed
   Print Chr(0);
   Print Chr(0);
   Print Chr(2);
   Print Chr(2);
   Numstr = Lookupstr(keynum , Menu3table)
   Print Numstr;
   Print Chr(0);
   Incr Keynum
   Temp = Ulcdwait()
 Next
End Sub

Sub Configurationmode()
 Call Drawmenu3()
 Do
  Hs = Checkhome()
  If Hs = 1 Then Exit Do
  Temp = Menu3selection()
  Select Case Temp
   Case Is = 0 : Call Configstepsperinch()
   Case Is = 1 : Call Configrapidrate()
   Case Is = 2 : Call Configramprate()
   Case Is = 3 : Call Configrpgcount()
   Case Is = 4 : Call Configdirection()
  End Select
  Waitms 100
 Loop
End Sub

Sub Configstepsperinch()
 Print "E";
 Temp = Ulcdwait()
 Keynum = 0
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
 Textcolourmsb = 255
 Textcolourlsb = 255
 T = "Enter Steps/inch"
 Call Lcdprintstring(1 , 1)
 Wait 2
 Call Drawkeypad
 T = "CURRENT="
 Call Lcdprintstring(19 , 1)
 If Nvsivalidflag = &HAA Then                               ' &hAA is the flag value when a valid steps per inch is stored in NV memory
  Stepsperinch = Nvstepsperinch
 Else
  Stepsperinch = 0
 End If
 T = Fusing(stepsperinch , "######.##")
 Textcolourmsb = 255                                        ' white text
 Textcolourlsb = 255
 Call Lcdprintstring(19 , 9)
 Stepsperinch = Getnumber()
 Nvstepsperinch = Stepsperinch
 Nvsivalidflag = &HAA
 For I = Xid To Zid
  Print #2 , Chr(i);
  Print #2 , "X";
  Print #2 , Stepsperinch
 Next
 Call Drawmenu3()
End Sub


Sub Configrapidrate()
 Print "E";
 Temp = Ulcdwait()
 Keynum = 0
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
 Textcolourmsb = 255
 Textcolourlsb = 255
 T = "Enter Rapid Rate"
 Call Lcdprintstring(1 , 1)
 Wait 2
 Call Drawkeypad
 T = "CURRENT="
 Call Lcdprintstring(19 , 1)
 If Nvrapidvalidflag = &HAA Then                            ' &hAA is the flag value when a valid steps per inch is stored in NV memory
  Rapidrate = Nvrapidrate
 Else
  Rapidrate = 0
 End If
 T = Fusing(rapidrate , "####.###")
 Textcolourmsb = 255                                        ' white text
 Textcolourlsb = 255
 Call Lcdprintstring(19 , 9)
 Rapidrate = Getnumber()
 Nvrapidrate = Rapidrate
 Nvrapidvalidflag = &HAA
 Call Drawmenu3()
End Sub

Sub Configramprate()
 Print "E";
 Temp = Ulcdwait()
 Keynum = 0
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
 Textcolourmsb = 255
 Textcolourlsb = 255
 T = "Enter Ramp Rate"
 Call Lcdprintstring(1 , 1)
 Wait 2
 Call Drawkeypad
 T = "CURRENT="
 Call Lcdprintstring(19 , 1)
 If Nvrampvalidflag = &HAA Then                             ' &hAA is the flag value when a valid steps per inch is stored in NV memory
  Ramprate = Nvramprate
 Else
  Ramprate = 10
 End If
 T = Fusing(ramprate , "####.###")
 Textcolourmsb = 255                                        ' white text
 Textcolourlsb = 255
 Call Lcdprintstring(19 , 9)
 Ramprate = Getnumber()
 Nvramprate = Ramprate
 Nvrampvalidflag = &HAA
 ' send the new parameter out to the 3 axis controllers
 For I = Xid To Zid
  Print #2 , Chr(i);
  Print #2 , "R";
  T = Fusing(ramprate , "####.")
  Print #2 , T
 Next
 Call Drawmenu3()
End Sub

Sub Configrpgcount()
 Print "E";
 Temp = Ulcdwait()
 Keynum = 0
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
 Textcolourmsb = 255
 Textcolourlsb = 255
 T = "Enter RPG pulses/step"
 Call Lcdprintstring(1 , 1)
 Wait 2
 Call Drawkeypad
 T = "CURRENT="
 Call Lcdprintstring(19 , 1)
 If Nvrpgvalidflag = &HAA Then                              ' &hAA is the flag value when a valid steps per inch is stored in NV memory
  Rpgcount = Nvrpgcount
 Else
  Rpgcount = 20
 End If
 T = Fusing(rpgcount , "####.")
 Textcolourmsb = 255                                        ' white text
 Textcolourlsb = 255
 Call Lcdprintstring(19 , 9)
 Rpgcount = Getnumber()
 Nvrpgcount = Rpgcount
 Nvrpgvalidflag = &HAA
 For I = Xid To Zid
  Print #2 , Chr(i);
  Print #2 , "P";
  T = Fusing(rpgcount , "#####.")
  Print #2 , T
 Next
 Call Drawmenu3()
End Sub

Sub Configdirection()
 Print "E";
 Temp = Ulcdwait()
 Keynum = 0
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
 Textcolourmsb = 255
 Textcolourlsb = 255
 T = "NORMAL INV."
 Call Lcdprintstring(0 , 9)
 T = "X Axis"
 Call Lcdprintstring(2 , 1)
 T = "Y Axis"
 Call Lcdprintstring(7 , 1)
 T = "Z Axis"
 Call Lcdprintstring(12 , 1)

 ' depending upon the stored state of the Axis invert flags, set up the display accordingly
 If Xaxisinvert = False Then
  Call Macro1()
 Else
  Call Macro2()
 End If
 If Yaxisinvert = False Then
  Call Macro3()
 Else
  Call Macro4()
 End If
 If Zaxisinvert = False Then
  Call Macro5()
 Else
  Call Macro6()
 End If



Do
 Print "o";
 Print Chr(4);
 Inputbin Tstemp
 If Tstemp = 256 Then
   Keyerr = False
   Call Gettouch(5)
   Select Case Touchx
     Case 125 To 155 : Keycol = 0
     Case 185 To 215 : Keycol = 1
     Case Else : Keyerr = True
   End Select
   Select Case Touchy
     Case 20 To 50 : Keyrow = 0
     Case 105 To 135 : Keyrow = 1
     Case 190 To 220 : Keyrow = 2
     Case Else : Keyerr = True
   End Select
   If Keyerr = False Then
    Shift Keyrow , Left , 1
    Keynum = Keyrow + Keycol
    Select Case Keynum
     Case Is = 0 : Call Macro1
     Case Is = 1 : Call Macro2
     Case Is = 2 : Call Macro3
     Case Is = 3 : Call Macro4
     Case Is = 4 : Call Macro5
     Case Is = 5 : Call Macro6
    End Select
   End If
 End If
 Hs = Checkhome()
 If Hs = 1 Then Exit Do
Loop
' update the axis invert flags in the NV memory
 I = Nvaxisinvert
 If Xaxisinvert = False Then
  Reset I.0
 Else
  Set I.0
 End If
 If Yaxisinvert = False Then
  Reset I.1
 Else
  Set I.1
 End If
 If Zaxisinvert = False Then
  Reset I.2
 Else
  Set I.2
 End If
 Nvaxisinvert = I                                           ' store to NV memory
 Call Drawmenu3()
End Sub


 ' set pensize to 1 for no filling
 Print "p";
 Print Chr(1);
 Temp = Ulcdwait()
 For Lcdy = 35 To 205 Step 85
 For Lcdx = 140 To 200 Step 60
   Print "C";
   Temp = High(lcdx)
   Print Chr(temp);
   Temp = Low(lcdx)
   Print Chr(temp);
   Temp = High(lcdy)
   Print Chr(temp);
   Temp = Low(lcdy)
   Print Chr(temp);
   Print Chr(0);
   Print Chr(12);                                           'Radius
   Print Chr(127);                                          'color
   Print Chr(63);                                           'color
   Temp = Ulcdwait()
   Next
 Next
 Print "O";
 Print Chr(0);
 Temp = Ulcdwait()
 'Call Gettouch(2)

Sub Macro1()
 Xaxisinvert = False
 ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 Lcdx = 140
 Lcdy = 35
 ' light green
 Colmsb = &B10000111
 Collsb = &B11110000
 Call Lcddrawcircle()
 Lcdx = 200
 Lcdy = 35
 Colmsb = 0
 Collsb = 0
 Call Lcddrawcircle()
 Print "p";
 Print Chr(1);
 Temp = Ulcdwait()
 Lcdx = 200
 Lcdy = 35
 Colmsb = 127
 Collsb = 63
 Call Lcddrawcircle()
End Sub

Sub Macro3()
 Yaxisinvert = False
 ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 Lcdx = 140
 Lcdy = 120
 ' light green
 Colmsb = &B10000111
 Collsb = &B11110000
 Call Lcddrawcircle()
 Lcdx = 200
 Lcdy = 120
 Colmsb = 0
 Collsb = 0
 Call Lcddrawcircle()
 Print "p";
 Print Chr(1);
 Temp = Ulcdwait()
 Lcdx = 200
 Lcdy = 120
 Colmsb = 127
 Collsb = 63
 Call Lcddrawcircle()
End Sub

Sub Macro5()
 Zaxisinvert = False
 ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 Lcdx = 140
 Lcdy = 205
 ' light green
 Colmsb = &B10000111
 Collsb = &B11110000
 Call Lcddrawcircle()
 Lcdx = 200
 Lcdy = 205
 Colmsb = 0
 Collsb = 0
 Call Lcddrawcircle()
 Print "p";
 Print Chr(1);
 Temp = Ulcdwait()
 Lcdx = 200
 Lcdy = 205
 Colmsb = 127
 Collsb = 63
 Call Lcddrawcircle()
End Sub

Sub Macro2()
 Xaxisinvert = True
 ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 Lcdx = 200
 Lcdy = 35
' light red
 Colmsb = &B11111100
 Collsb = &B000010000
 Call Lcddrawcircle()
 Lcdx = 140
 Lcdy = 35
 Colmsb = 0
 Collsb = 0
 Call Lcddrawcircle()
 Print "p";
 Print Chr(1);
 Temp = Ulcdwait()
 Lcdx = 140
 Lcdy = 35
 Colmsb = 127
 Collsb = 63
 Call Lcddrawcircle()
End Sub

Sub Macro4()
 Yaxisinvert = True
 ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 Lcdx = 200
 Lcdy = 120
' light red
 Colmsb = &B11111100
 Collsb = &B000010000
 Call Lcddrawcircle()
 Lcdx = 140
 Lcdy = 120
 Colmsb = 0
 Collsb = 0
 Call Lcddrawcircle()
 Print "p";
 Print Chr(1);
 Temp = Ulcdwait()
 Lcdx = 140
 Lcdy = 120
 Colmsb = 127
 Collsb = 63
 Call Lcddrawcircle()
End Sub

Sub Macro6()
 Zaxisinvert = True
 ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 Lcdx = 200
 Lcdy = 205
' light red
 Colmsb = &B11111100
 Collsb = &B000010000
 Call Lcddrawcircle()
 Lcdx = 140
 Lcdy = 205
 Colmsb = 0
 Collsb = 0
 Call Lcddrawcircle()
 Print "p";
 Print Chr(1);
 Temp = Ulcdwait()
 Lcdx = 140
 Lcdy = 205
 Colmsb = 127
 Collsb = 63
 Call Lcddrawcircle()
End Sub

Sub Comment()
 Eolflag = True
End Sub

Sub Rapid()
  Rapidflag = False
  ' convert rapid rate to pulses/sec
  Stemp = Rapidrate * Stepsperinch
  Pulserate = Stemp / 60.0
 ' first send out X axis params
 Xtemp = Targetx - Currentx
 If Xtemp <> 0 Then
  Rapidflag = True
  Motionflag = True
  Print #2 , Chr(xid);
  Print #2 , "S";
  T = Fusing(pulserate , "#####.###")
  Print #2 , T
 ' calculate the required X displacement
  Xtemp = Xtemp * 1000                                      ' convert to mils
  Print #2 , Chr(xid);
  Print #2 , "D";
  Sdtemp = Xtemp                                            'convert double to single
  T = Fusing(sdtemp , "#####.")
  Print #2 , T
  ' Print #3 , "Xdispl= " ; T
  Call Waitforexecution()
 ' update the parameter
  Currentx = Targetx
 End If
 ' next send out Y axis params
 Ytemp = Targety - Currenty
 If Ytemp <> 0 Then
  Rapidflag = True
  Motionflag = True
  Print #2 , Chr(yid);
  Print #2 , "S";
  T = Fusing(pulserate , "#####.###")
  Print #2 , T
 ' calculate the required Y displacement
  Ytemp = Ytemp * 1000                                      ' convert to mils
  Sdtemp = Ytemp                                            'convert double to single
  T = Fusing(sdtemp , "#####.")
  Print #2 , Chr(yid);
  Print #2 , "D";
  Print #2 , T
  ' Print #3 , "ydispl= " ; T
  Call Waitforexecution()
 ' update the parameter
  Currenty = Targety
 End If
 ' next send out Z axis params
 Ztemp = Targetz - Currentz
 If Ztemp <> 0 Then
  Rapidflag = True
  Motionflag = True
  Print #2 , Chr(zid);
  Print #2 , "S";
  T = Fusing(pulserate , "#####.###")
  Print #2 , T
  ' Print #3 , "Rapid rate = " ; T
' calculate the required Z displacement
  Ztemp = Ztemp * 1000                                      ' convert to mils
  Sdtemp = Ztemp                                            'convert double to single
  T = Fusing(sdtemp , "#####.")
  Print #2 , Chr(zid);
  Print #2 , "D";
  Print #2 , T
  ' Print #3 , "zdispl= " ; T
  Call Waitforexecution()
 ' update the parameter
  Currentz = Targetz
 End If
' Wait 5
' If Rapidflag = True Then Call Waitforexecution()
End Sub

Sub Linear()
' first find out which axis has the largest displacement
Xtemp = Targetx - Currentx
Xtemp1 = Abs(xtemp)
Ytemp = Targety - Currenty
Ytemp1 = Abs(ytemp)
Ztemp = Targetz - Currentz
Ztemp1 = Abs(ztemp)
If Xtemp1 >= Ytemp1 Then Goto Llab3
' Y motion > X motion
If Ytemp1 >= Ztemp1 Then Goto Llab6
Goto Llab4
Llab3:
If Xtemp1 >= Ztemp1 Then Goto Llab5

' Z motion has the largest displacement
Llab4:
'Print #1 , "Z is largest displ"
Feedratez = Feedrate                                        ' make Z axis speed = feedrate directly
Frratio = Xtemp1 / Ztemp1
Stemp = Frratio
Feedratex = Feedrate * Stemp                                ' make X axis speed = (Xdisp/Zdisp) * prog. feedrate
'Print #1 , Feedratex
Frratio = Ytemp1 / Ztemp1
Stemp = Frratio
Feedratey = Feedrate * Stemp                                ' make X axis speed = (Xdisp/Zdisp) * prog. feedrate
'Print #1 , Feedratey
'Print #1 , Feedratez
Goto Llab7

' X has the largest displacement
Llab5:
'Print #1 , "X is largest displ"
Feedratex = Feedrate                                        ' make X axis speed = prog feedrate
Frratio = Ytemp1 / Xtemp1
Stemp = Frratio
Feedratey = Feedrate * Stemp                                ' make Y axis speed = (Ydisp/Xdisp) * prog. feedrate
Frratio = Ztemp1 / Xtemp1
Stemp = Frratio
Feedratez = Feedrate * Stemp                                ' make Z axis speed = (Zdisp/Xdisp) * prog. feedrate
Goto Llab7

' Y has the largest displacement
Llab6:
'Print #1 , "Y is largest displ"
Feedratey = Feedrate                                        ' make Y axis speed = feedrate directly
Frratio = Xtemp1 / Ytemp1
Stemp = Frratio
Feedratex = Feedrate * Stemp                                ' make X axis speed = (Xdisp/Zdisp) * prog. feedrate
Frratio = Ztemp1 / Ytemp1
Stemp = Frratio
Feedratez = Feedrate * Stemp                                ' make X axis speed = (Xdisp/Zdisp) * prog. feedrate

Llab7:
 ' convert inches per minute into pulse rate in hertz for each axis individually
  ' Print #3 , "pulserates = "

 Stemp = Feedratex * Stepsperinch
 Pulseratex = Stemp / 60.0

 Stemp = Feedratey * Stepsperinch
 Pulseratey = Stemp / 60.0

 Stemp = Feedratez * Stepsperinch
 Pulseratez = Stemp / 60.0

 T = Fusing(pulseratex , "#####.###")
 ' Print #3 , T
 T = Fusing(pulseratey , "#####.###")
 ' Print #3 , T
  T = Fusing(pulseratez , "#####.###")
 ' Print #3 , T
  ' first send out X axis params (if X displacment <> 0 )
 If Xtemp <> 0 Then
  Print #2 , Chr(xid);
  Print #2 , "S";
  T = Fusing(pulseratex , "#####.###")
  Print #2 , T
 ' convert the required X displacement into mils
  Xtemp = Xtemp * 1000                                      ' convert to mils
  Print #2 , Chr(xid);
  Print #2 , "D";
  Sdtemp = Xtemp                                            'convert double to single
  T = Fusing(sdtemp , "#####.")
  Print #2 , T
  ' Print #3 , "Xdispl= " ; T
 End If

 ' next send out Y axis params  (if Y displacement <>0)
  If Ytemp <> 0 Then
  Print #2 , Chr(yid);
  Print #2 , "S";
  T = Fusing(pulseratey , "#####.###")
   Print #2 , T
 ' convert the required Y displacement into mils
  Ytemp = Ytemp * 1000                                      ' convert to mils
  Sdtemp = Ytemp                                            'convert double to single
  T = Fusing(sdtemp , "#####.")
  Print #2 , Chr(yid);
  Print #2 , "D";
  Print #2 , T
  ' Print #3 , "ydispl= " ; T
 End If

 ' next send out Z axis params (if Z displacment <>0)
 If Ztemp <> 0 Then
  Print #2 , Chr(zid);
  Print #2 , "S";
  T = Fusing(pulseratez , "#####.###")
  Print #2 , T
' convert the required Z displacement into mils
  Ztemp = Ztemp * 1000                                      ' convert to mils
  Sdtemp = Ztemp                                            'convert double to single
  T = Fusing(sdtemp , "#####.")
  Print #2 , Chr(zid);
  Print #2 , "D";
  Print #2 , T
  ' Print #3 , "zdispl= " ; T
 End If
' Waitms 25                                                  ' wait til messages have been received by all modules

 Call Waitforexecution()
  ' update the parameters
 Currentx = Targetx
 Currenty = Targety
 Currentz = Targetz
' Wait 5
End Sub

Sub Waitforexecution()
 Reset Nexecute                                             ' toggle the *Execute line low
 Bitwait Doneflag , Reset                                   ' wait til Axis controller indicates it's busy
' Waitms 4
 ' Print #3 , "waiting for done flag"

 Do
 If Estopswitch = 0 Then
  Estop = True
  Reset Faultled
  Abortflag = True
  Reset Nfaultout                                           'send a fault condition to the 3 axis controllers
  Reset Motor1                                              ' turn off spindle motor
  Lcdrow = 1
  Lcdcol = 13
  ' set text colour to light red
  Textcolourmsb = &B11111100
  Textcolourlsb = &B00010000
  T = "E-STOP"
  Call Lcdprintstring(lcdrow , Lcdcol)
  Exit Do
 End If

 If Limitswitchin = 1 Then
  Limitswitch = True
  Reset Faultled
  Abortflag = True
  Reset Nfaultout                                           'send a fault condition to the 3 axis controllers
  Reset Motor1                                              ' turn off spindle motor
  Lcdrow = 1
  Lcdcol = 13
  ' set text colour to light red
  Textcolourmsb = &B11111100
  Textcolourlsb = &B00010000
  T = "LIMIT "
  Call Lcdprintstring(lcdrow , Lcdcol)
  Exit Do
 End If


  Temp = Menu2selection()
' during execution of this move, check to see if STOP or PAUSE button pushed on T screen
  If Temp = 3 Then
    Abortflag = True
    Reset Nfaultout                                         'simulate a fault condition to the 3 axis controllers
    Lcdrow = 0
    Lcdcol = 13
    ' set text colour to light red
    Textcolourmsb = &B11111100
    Textcolourlsb = &B00010000
    T = " STOP"
    Call Lcdprintstring(lcdrow , Lcdcol)
    Exit Do
  End If
  If Temp = 1 Then
    Pauseflag = True
    Lcdrow = 0
    Lcdcol = 13
    ' set text colour to light blue
    Textcolourmsb = &B10000100                              ' light blue
    Textcolourlsb = &B00011111
    T = "PAUSE"
    Call Lcdprintstring(lcdrow , Lcdcol)
  End If
 Loop Until Doneflag = 1
 Set Nexecute
' Print #3 , "done flag sensed"

End Sub

Sub Circularcw()
End Sub

Sub Circularccw()
End Sub

Sub Getcurrentx()
 Print #2 , Chr(129);                                       'set Axis ID to X
 Print #2 , "?"
 Input #2 , Currentx
End Sub

Sub Getcurrenty()
 Print #2 , Chr(129);                                       'set Axis ID to X
 Print #2 , "?"
 Input #2 , Currenty
End Sub

Sub Getcurrentz()
 Print #2 , Chr(129);                                       'set Axis ID to X
 Print #2 , "?"
 Input #2 , Currentz
End Sub

Sub Parseerror()
 ' Print #3 , "R= " ; Asc(r)
 I = Cmdlen - Cmdptr
 Perstring = Right(cmdstring , I)
 ' Print #3 , Perstring
 Eolflag = True
End Sub

Sub Feedparam()
 ' Print #3 , "found F param ";
 Incr Cmdptr
 Call Getnumeric()
 Feedrate = Val(paramstr)
 ' convert inches per minute into pulse rate in hertz
 Stemp = Feedrate * Stepsperinch
 Pulserate = Stemp / 60.0
 T = Fusing(pulserate , "#####.###")
 ' Print #3 , "pulserate= " ; T
End Sub

Sub Gparam()
 ' Print #3 , "found G param= ";
 Incr Cmdptr
 Call Getnumeric()
 Gomode = Val(paramstr)
 ' Print #3 , Gomode
 Motionflag = True
 ' after seeing a Gxx command, we set the target axis values to the current ones
 ' because not all X,Y Z targets will be stated on the command  line, unless they change
 Targetx = Currentx
 Targety = Currenty
 Targetz = Currentz
 End Sub

 ' SPINDLE SPEED parameter- not implemented
Sub Sparam()
 ' Print #3 , "found S param= ";
 Incr Cmdptr
 Call Getnumeric()
End Sub

Sub Xparam()
 ' Print #3 , "found X param= ";
 Incr Cmdptr
 Call Getnumeric()
 Targetx = Val(paramstr)
 ' Print #3 , Targetx
 If Targetx <> Currentx Then
  Motionflag = True
 End If
End Sub

Sub Yparam()
 ' Print #3 , "found Y param=";
 Incr Cmdptr
 Call Getnumeric()
 Targety = Val(paramstr)
 ' Print #3 , Targety
 If Targety <> Currenty Then
  Motionflag = True
 End If
End Sub

Sub Zparam()
 ' Print #3 , "found Z param=";
 Incr Cmdptr
 Call Getnumeric()
 Targetz = Val(paramstr)
 ' Print #3 , Targetz
 If Targetz <> Currentz Then
  Motionflag = True
 End If
End Sub


Sub Mparam()
 ' Print #3 , "found M param= ";
 Incr Cmdptr
 Call Getnumeric()
 Mmode = Val(paramstr)
 Select Case Mmode
  Case Is = 2 : Eopflag = True
  Case Is = 3 : Set Motor1
'  Case Is = 4 : Set Motor2
  Case Is = 5 : Reset Motor1
'  Case Is = 7 : Set Coolant
'  Case Is = 8 : Set Coolant
'  Case Is = 9 : Reset Coolant
 End Select
 ' Print #3 , Mmode
End Sub

Sub Nparam()
 ' Print #3 , "found line number= ";
 Incr Cmdptr
 Call Getnumeric()
 ' Print #3 , Paramstr
End Sub

Sub Getnumeric()
 Call Skipspace()
 Paramstr = ""
 Do
  If Cmdptr > Cmdlen Then
   Eolflag = True
   Exit Do
  End If
  R = Mid(cmdstring , Cmdptr , 1)
  If R = " " Then Exit Do
  If R = Chr(9) Then Exit Do
  Paramstr = Paramstr + R
  Incr Cmdptr
 Loop
End Sub

Sub Skipspace()
 Do
  If Cmdptr > Cmdlen Then
    Eolflag = True
    Exit Do
  End If
  Pflag = True
  R = Mid(cmdstring , Cmdptr , 1)
  If R = " " Then Pflag = False
  If R = Chr(9) Then Pflag = False                          ' TAB
  Incr Cmdptr
 Loop Until Pflag = True
 Decr Cmdptr
End Sub

Sub Getnvaxisinvert()
 I = Nvaxisinvert
 If I = 255 Then                                            ' if NV params not set yet, then set them to X,Y,Z= normal
  I = 0
  Nvaxisinvert = I
 Else
  If I.0 = 1 Then
   Xaxisinvert = True
  Else
   Xaxisinvert = False
  End If
  If I.1 = 1 Then
   Yaxisinvert = True
  Else
   Yaxisinvert = False
  End If
  If I.2 = 1 Then
   Zaxisinvert = True
  Else
   Zaxisinvert = False
  End If
 End If
End Sub


'***********************************
'* LCD TouchScreen Routines follow *
'***********************************

Function Ulcdwait()
 Inputbin , Ch
 Ulcdwait = Ch
End Function

Sub Drawfilescreen()
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
 ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 ' Set transparent Text so button text can be seen
 Print "O";
 Print Chr(0);
 Temp = Ulcdwait()
 Print "r";
 Print Chr(0);
 Print Chr(165);
 Print Chr(0);
 Print Chr(35);
 Print Chr(0);
 Print Chr(215);
 Print Chr(0);
 Print Chr(95);
 Print Chr(07);
 Print Chr(&B11100000);
 Temp = Ulcdwait()

  Print "r";
 Print Chr(0);
 Print Chr(165);
 Print Chr(0);
 Print Chr(110);
 Print Chr(0);
 Print Chr(215);
 Print Chr(0);
 Print Chr(170);
 Print Chr(07);
 Print Chr(&B11100000);
 Temp = Ulcdwait()

  Print "G";
 Print Chr(0);
 Print Chr(150);
 Print Chr(0);
 Print Chr(35);
 Print Chr(0);
 Print Chr(190);
 Print Chr(0);
 Print Chr(15);
 Print Chr(0);
 Print Chr(230);
 Print Chr(0);
 Print Chr(35);
 Print Chr(0);
 Print Chr(&B00011000);
 Temp = Ulcdwait()

  Print "G";
 Print Chr(0);
 Print Chr(150);
 Print Chr(0);
 Print Chr(170);
 Print Chr(0);
 Print Chr(230);
 Print Chr(0);
 Print Chr(170);
 Print Chr(0);
 Print Chr(190);
 Print Chr(0);
 Print Chr(190);
 Print Chr(0);
 Print Chr(&B00011000);
 Temp = Ulcdwait()

    ' place the Select button
   Print "b";
   Print Chr(1);
   Print Chr(0);
   Print Chr(150);
   Print Chr(0);
   Print Chr(220);
   Print Chr(127);                                          'color
   Print Chr(63);                                           'color
   Print Chr(3);                                            'font
   Print Chr(0);
   Print Chr(0);
   Print Chr(1);
   Print Chr(1);
   Print "Select";
   Print Chr(0);
   Temp = Ulcdwait()

 ' set pensize to 1 for wire-frame
 Print "p";
 Print Chr(1);
 Temp = Ulcdwait()
' draw a box around the filename list
 Print "r";
 Print Chr(0);
 Print Chr(0);
 Print Chr(0);
 Print Chr(0);
 Print Chr(0);
 Print Chr(130);
 Print Chr(1);
 Print Chr(20);
 Print Chr(255);
 Print Chr(255);
 Temp = Ulcdwait()
 End Sub

Sub Drawjogpad()
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
 ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 ' Set transparent Text so button text can be seen
 Print "O";
 Print Chr(0);
 Temp = Ulcdwait()
 Print "r";
 Print Chr(0);
 Print Chr(95);
 Print Chr(0);
 Print Chr(30);
 Print Chr(0);
 Print Chr(145);
 Print Chr(0);
 Print Chr(90);
 Print Chr(07);
 Print Chr(&B11100000);
 Temp = Ulcdwait()

  Print "r";
 Print Chr(0);
 Print Chr(95);
 Print Chr(0);
 Print Chr(160);
 Print Chr(0);
 Print Chr(145);
 Print Chr(0);
 Print Chr(220);
 Print Chr(07);
 Print Chr(&B11100000);
 Temp = Ulcdwait()

 Print "r";
 Print Chr(0);
 Print Chr(35);
 Print Chr(0);
 Print Chr(100);
 Print Chr(0);
 Print Chr(94);
 Print Chr(0);
 Print Chr(150);
 Print Chr(07);
 Print Chr(&B11100000);
 Temp = Ulcdwait()

  Print "r";
 Print Chr(0);
 Print Chr(145);
 Print Chr(0);
 Print Chr(100);
 Print Chr(0);
 Print Chr(210);
 Print Chr(0);
 Print Chr(150);
 Print Chr(07);
 Print Chr(&B11100000);
 Temp = Ulcdwait()

  Print "G";
 Print Chr(0);
 Print Chr(120);
 Print Chr(0);
 Print Chr(0);
 Print Chr(0);
 Print Chr(80);
 Print Chr(0);
 Print Chr(30);
 Print Chr(0);
 Print Chr(160);
 Print Chr(0);
 Print Chr(30);
 Print Chr(0);
 Print Chr(&B00011000);
 Temp = Ulcdwait()

  Print "G";
 Print Chr(0);
 Print Chr(80);
 Print Chr(0);
 Print Chr(220);
 Print Chr(0);
 Print Chr(120);
 Print Chr(0);
 Print Chr(250);
 Print Chr(0);
 Print Chr(160);
 Print Chr(0);
 Print Chr(220);
 Print Chr(0);
 Print Chr(&B00011000);
 Temp = Ulcdwait()

  Print "G";
 Print Chr(0);
 Print Chr(35);
 Print Chr(0);
 Print Chr(85);
 Print Chr(0);
 Print Chr(5);
 Print Chr(0);
 Print Chr(125);
 Print Chr(0);
 Print Chr(35);
 Print Chr(0);
 Print Chr(165);
 Print Chr(0);
 Print Chr(&B00011000);
 Temp = Ulcdwait()

  Print "G";
 Print Chr(0);
 Print Chr(210);
 Print Chr(0);
 Print Chr(85);
 Print Chr(0);
 Print Chr(239);
 Print Chr(0);
 Print Chr(125);
 Print Chr(0);
 Print Chr(210);
 Print Chr(0);
 Print Chr(165);
 Print Chr(0);
 Print Chr(&B00011000);
 Temp = Ulcdwait()

    ' place the Down button
 Print "b";
 Print Chr(1);
 Print Chr(0);
 Print Chr(25);
 Print Chr(1);
 Print Chr(25);
 Print Chr(127);                                            'color
 Print Chr(63);                                             'color
 Print Chr(2);                                              'font
 Print Chr(0);
 Print Chr(0);
 Print Chr(2);
 Print Chr(2);
 Print "Down";
 Print Chr(0);
 Temp = Ulcdwait()

     ' place the Up button
 Print "b";
 Print Chr(1);
 Print Chr(0);
 Print Chr(150);
 Print Chr(1);
 Print Chr(25);
 Print Chr(127);                                            'color
 Print Chr(63);                                             'color
 Print Chr(2);                                              'font
 Print Chr(0);
 Print Chr(0);
 Print Chr(2);
 Print Chr(2);
 Print " Up ";
 Print Chr(0);
 Temp = Ulcdwait()
 End Sub


Sub Drawkeypad()
Keynum = 1
 ' clear the screen
 Print "E";
 Temp = Ulcdwait()
 ' set pensize to 0 for filling
 Print "p";
 Print Chr(0);
 Temp = Ulcdwait()
 ' Set transparent Text so button text can be seen
 Print "O";
 Print Chr(0);
 Temp = Ulcdwait()
 Print "r";
 Print Chr(0);
 Print Chr(10);
 Print Chr(0);
 Print Chr(40);
 Print Chr(0);
 Print Chr(239);
 Print Chr(1);
 Print Chr(35);
 Print Chr(0);
 Print Chr(&B00011000);
 Temp = Ulcdwait()
 ' set pensize to 1 for no filling
 Print "p";
 Print Chr(1);
 Temp = Ulcdwait()
 Print "r";
 Print Chr(0);
 Print Chr(10);
 Print Chr(0);
 Print Chr(0);
 Print Chr(0);
 Print Chr(239);
 Print Chr(0);
 Print Chr(40);
 Print Chr(255);
 Print Chr(255);
 Temp = Ulcdwait()
 For Lcdy = 50 To 180 Step 65
 For Lcdx = 25 To 205 Step 60
   Print "b";
   Print Chr(1);
   Temp = High(lcdx)
   Print Chr(temp);
   Temp = Low(lcdx)
   Print Chr(temp);
   Temp = High(lcdy)
   Print Chr(temp);
   Temp = Low(lcdy)
   Print Chr(temp);
   Print Chr(127);                                          'color
   Print Chr(63);                                           'color
   Print Chr(2);                                            'font
   Print Chr(0);
   Print Chr(0);
   Print Chr(2);
   Print Chr(2);
   Print Chr(keypad(keynum));
   Print Chr(0);
   Incr Keynum
   Temp = Ulcdwait()
   Next
 Next
   ' place the Delete button
   Print "b";
   Print Chr(1);
   Print Chr(0);
   Print Chr(100);
   Print Chr(0);
   Print Chr(250);
   Print Chr(127);                                          'color
   Print Chr(63);                                           'color
   Print Chr(2);                                            'font
   Print Chr(0);
   Print Chr(0);
   Print Chr(2);
   Print Chr(2);
   Print "Del";
   Print Chr(0);
   Temp = Ulcdwait()
End Sub

Sub Lcdprintch(ch As Byte)
 Print "T";
  Print Chr(ch);
  Print Chr(lcdcol);
  Print Chr(lcdrow);
  Print Chr(255);
  Print Chr(255);
 Temp = Ulcdwait()
End Sub

Sub Lcdprintstring(byval Row As Byte , Byval Col As Byte)
   Print "s";
   Print Chr(col);                                          ' Horiz pos
   Print Chr(row);                                          ' vert position
   Print Chr(3);                                            ' largest font
   Print Chr(textcolourmsb);                                'color
   Print Chr(textcolourlsb);
   Print T;
   Print Chr(0);
   Temp = Ulcdwait()
End Sub

Sub Lcddrawcircle()
   Print "C";
   Temp = High(lcdx)
   Print Chr(temp);
   Temp = Low(lcdx)
   Print Chr(temp);
   Temp = High(lcdy)
   Print Chr(temp);
   Temp = Low(lcdy)
   Print Chr(temp);
   Print Chr(0);
   Print Chr(12);                                           'Radius
   Print Chr(colmsb);                                       'color
   Print Chr(collsb);                                       'color
   Temp = Ulcdwait()
End Sub



Sub Gettouch(mode As Byte)
 Print "o";
 Print Chr(mode);
 Inputbin Msb
 Inputbin , Lsb
 Touchx = Makeint(lsb , Msb)
 Inputbin Msb
 Inputbin Lsb
 Touchy = Makeint(lsb , Msb)
End Sub

' this function returns
' 0- if no touch
' 1- X- pressed
' 2- X+ pressed
' 3- Y+ pressed
' 4- Y- pressed
' 5- Down pressed
' 6- Up pressed
' 255- invalid touch

Function Getjogpod() As Byte
 If Limitswitchin = 1 Then
  Limitswitch = True
  Reset Faultled
  Getjogpod = 0
  Print "O";                                                'non transparent text- allows erasure
  Print Chr(1);
   Temp = Ulcdwait()
  Lcdrow = 1
  Lcdcol = 13
  ' set text colour to light red
  Textcolourmsb = &B11111100
  Textcolourlsb = &B00010000
  T = "LIMIT"
  Call Lcdprintstring(lcdrow , Lcdcol)
  Exit Function
 End If
 If Limitswitchin = 0 Then
  If Limitswitch = True Then
   Limitswitch = False
   Print "O";                                               'non transparent text- allows erasure
   Print Chr(1);
   Temp = Ulcdwait()
   Lcdrow = 1
   Lcdcol = 13
 ' set text colour to light green
   Textcolourmsb = 7
   Textcolourlsb = &HE0
   T = "  OK  "
   Call Lcdprintstring(lcdrow , Lcdcol)
   End If
 End If
 Getjogpod = 255
 Set Faultled
 Print "o";
 Print Chr(4);
 Inputbin Tstemp
 If Tstemp = 0 Then
  Getjogpod = 0
  Exit Function
 End If

 If Tstemp <> 512 Then
 Call Gettouch(5)

  If Touchy > 100 Then
   If Touchy < 140 Then
    If Touchx > 160 Then
     If Touchx < 250 Then
         Print #2 , Chr(xid);
         Print #2 , "A"
         Reset Nexecute
       Getjogpod = 2
       Exit Function
     End If
    Else
    If Touchx < 120 Then
     If Touchx > 40 Then
         Print #2 , Chr(xid);
         Print #2 , "B"
         Reset Nexecute
      Getjogpod = 1
      Exit Function
     End If
    End If
   End If
  End If
  End If

  If Touchx > 100 Then
   If Touchx < 140 Then
    If Touchy > 160 Then
     If Touchy < 250 Then
         Print #2 , Chr(yid);
         Print #2 , "B"
         Reset Nexecute
       Getjogpod = 4
       Exit Function
     End If
    Else
    If Touchy < 80 Then
         Print #2 , Chr(yid);
         Print #2 , "A"
         Reset Nexecute
      Getjogpod = 3
      Exit Function
    End If
   End If
  End If
  End If

  If Touchy > 260 Then
   If Touchx < 100 Then
      Print #2 , Chr(zid);
      Print #2 , "B"
      Reset Nexecute
    Getjogpod = 5
    Exit Function
   End If
   If Touchx > 140 Then
       Print #2 , Chr(zid);
       Print #2 , "A"
       Reset Nexecute
    Getjogpod = 6
    Exit Function
   End If
  End If
 End If
 End Function

' this function returns
' 0- when touch screen not pressed
' 1- when the "previous filename icon is pushed
' 2- when the "next" filename icon is pressed
' 3- when the Select button is pressed
' 255- if the screen is pressed in a non-defined area

Function Getfileselect() As Byte
 Getfileselect = 255
 Print "o";
 Print Chr(4);
 Inputbin Tstemp
 If Tstemp = 0 Then
  Getfileselect = 0
  Exit Function
 End If

 If Tstemp <> 512 Then
  Call Gettouch(5)
  If Touchx > 160 Then
   If Touchx < 220 Then
    If Touchy > 110 Then
     If Touchy < 170 Then
'       ' Print #3 , "incr filename"
       Getfileselect = 2
       Exit Function
     End If
    Else
    If Touchy > 30 Then
     If Touchy < 100 Then
'       ' Print #3 , "decr filename"
      Getfileselect = 1
      Exit Function
     End If
'     End If
     End If
    End If
   End If
  End If
 If Touchx > 150 Then
   If Touchx < 239 Then
    If Touchy > 200 Then
     If Touchy < 250 Then
        Getfileselect = 3
        Exit Function
     End If
    End If
   End If
  End If
 End If
End Function

Function Getkey() As Byte
 Keyerr = False
 Delkey = False
 Call Gettouch(1)
 Select Case Touchx
  Case 15 To 45 : Keycol = 1
  Case 85 To 105 : Keycol = 2
  Case 145 To 175 : Keycol = 3
  Case 200 To 230 : Keycol = 4
  Case Else : Keyerr = True
 End Select
 Select Case Touchy
  Case 45 To 75 : Keyrow = 0
  Case 110 To 140 : Keyrow = 1
  Case 180 To 210 : Keyrow = 2
  Case 250 To 280 : Delkey = True
  Case Else : Keyerr = True
 End Select

 If Delkey = True Then
  Keyerr = True
   If Lcdcol > 1 Then
    Decr Lcdcol
    Temp = &H20                                             ' rub out char with a space char
    Call Lcdprintch(temp)
    Strlen = Len(numstr)
    Decr Strlen
    Numstr = Left(numstr , Strlen)
   End If
  End If
 If Keyerr = False Then
   Keynum = Keyrow * 4
   Keynum = Keynum + Keycol
   S = Keypad(keynum)
   Getkey = Asc(s)
 Else
   Getkey = 0
 End If
 Call Gettouch(2)
End Function

Function Getnumber()
 Numstr = ""
 Lcdrow = 1
 Lcdcol = 1
 ' Set Opaque Text (so DEL key can rub out the char)
 Print "O";
 Print Chr(1);
 Temp = Ulcdwait()
 Do
   I = Getkey()
   If I = Asc( "E") Then Exit Do
   If I <> 0 Then
     Call Lcdprintch(i)
     Numstr = Numstr + Chr(i)
     Incr Lcdcol
   End If
 Loop
 If Len(numstr) > 0 Then
  Strtemp = Val(numstr)
  Getnumber = Strtemp
 Else
 Getnumber = -9999
 End If
End Function

Sub Initulcd32()
Print "U";                                                  'autobaud cmd
 Temp = Ulcdwait()
 Print "E";
 Temp = Ulcdwait()
 ' make touch screen active
 Print "Y";
 Print Chr(5);
 Print Chr(0);
 Temp = Ulcdwait()
  Print "Y";
 Print Chr(5);
 Print Chr(2);
 Temp = Ulcdwait()
 ' set font size=3
 Print "F";
 Print Chr(3);
 Temp = Ulcdwait()
End Sub

Sub Getfirstlineoffile()
 ' Set opaque Text so erase can occur
 Print "O";
 Print Chr(1);
 Temp = Ulcdwait()
 Cmdstring = Space(90)
 'erase any existing string
 Print "s";
 Print Chr(0);
 Print Chr(36);
 Print Chr(&H11);                                           ' 8X8 font in proportional mode
 Print Chr(255);                                            'color
 Print Chr(255);
 Print Cmdstring;
 Print Chr(0);
 Temp = Ulcdwait()
 S = Tapfiles(filenameindex)
 S = S + ".tap"
 ' Print #3 , S
 Open S For Input As #10
 Lineinput #10 , Cmdstring
 Close #10
 Cmdstring = Left(cmdstring , 64)
 ' Print #3 , Cmdstring
 Print "s";
 Print Chr(0);
 Print Chr(36);
 Print Chr(&H11);                                           ' 8X8 font in proportional mode
 Print Chr(255);                                            'color
 Print Chr(255);
 Print Cmdstring;
 Print Chr(0);
 Temp = Ulcdwait()
End Sub

Sub Checkrpg()
 If Limitswitch = False Then
  If Rechangeflag = True Then
   Rechangeflag = False
   If Reincrflag = True Then
    Print #2 , Chr(rpgaxisid) ; "E";
   Else
    Print #2 , Chr(rpgaxisid) ; "F";
   End If
  End If
 End If
End Sub

Sub Spindleoff()
 Reset Motor1
End Sub

Nlimitinisr:
 If Limitswitchin = 1 Then
  Waitms 50
  If Limitswitchin = 1 Then
    Reset Nfaultout
    Reset Faultled
    Limitswitch = True
    ' Print #3 , "LIMIT SWITCH"
    Print "O";                                              'non transparent text- allows erasure
    Print Chr(1);
    Temp = Ulcdwait()
    Lcdrow = 1
    Lcdcol = 13
    ' set text colour to light red
    Textcolourmsb = &B11111100
    Textcolourlsb = &B00010000
    T = "LIMIT "
    Call Lcdprintstring(lcdrow , Lcdcol)
  End If
 Else
  Waitms 50
  If Limitswitchin = 0 Then
    Limitswitch = False
    Set Nfaultout
    Set Faultled
    Print "O";                                              'non transparent text- allows erasure
    Print Chr(1);
    Temp = Ulcdwait()
    Lcdrow = 1
    Lcdcol = 13
    ' set text colour to light green
    Textcolourmsb = 7
    Textcolourlsb = &HE0
    T = "  OK  "
    Call Lcdprintstring(lcdrow , Lcdcol)
  End If
 End If
Return




' 500 Hz timer provides a 500 Hz clock to all Mega88 Axis controllers, to time the refresh of their LED display
' the 500 Hz ISR polls the MPG rotary encoder, and sets flags, for use in the mainline code
500hzisr:
  Retemp = Encoder(pinc.6 , Pinc.7 , Reup , Redown , 0)
Return

Reup:
 Reincrflag = True
 Goto Reex

Redown:
 Reincrflag = False
Reex:
 Rechangeflag = True
 If Rpgxswitch = 0 Then Rpgaxisid = Xid
 If Rpgyswitch = 0 Then Rpgaxisid = Yid
 If Rpgzswitch = 0 Then Rpgaxisid = Zid
 If Rpgaswitch = 0 Then Rpgaxisid = Aid
Return

End
Menu1table:
Data "  Manual Mode " , "Execute G-Code" , " Configuration" , "View Config  "



Menu2table:
Data "  START  " , "  PAUSE  " , " CONTINUE" , "  STOP   "

Menu3table:
Data "Config steps/inch" , "Config Rapid rate" , "Config Ramp rate" , "config RPG steps" , "Config Directions"