' CNC Individual Axis controller
' look-up table modified to reflect new (PCB) wiring to LED segments
' change the jog routines to activate by the CNC host controller board
' added RPG routines
' added goto zero switch handling
' reduced baudrate back to 38400!
' added  support for continued operation in manual mode, after an e-stop or other abort
' fixed bug with wrong ramping in G-code mode, after jogging had occurred in manual mode
' slowed jogfast down to 5000 to suit my mill
' fixed bug in ramp down (ramploopct var was not used)

$regfile = "m88def.dat"
$prog &HFF , &HC7 , &HD7 , &HF9
$crystal = 20000000
$baud = 38400
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Displacetemp As Long
Dim Ltemp As Long
Dim Ltemp1 As Long
Dim Ltemp2 As Long
Dim Rate As Double
Dim E As Byte
Dim I As Byte
Dim J As Byte
Dim Zz As Byte
Dim Pulsetemp As Word
Dim Xsteps As Long
Dim Xtemp As Long
Dim Doneflag As Boolean
Dim Currentx As Long
Dim Xdisplacement As Long
Dim Halfway As Long
Dim Rampstepcount As Long
Dim Stepsperinch As Long
Dim Displayvalue As Long
Dim Commandstr As String * 24
Dim Dstring As String * 30
Dim Strtemp As String * 30
Dim S2temp As String * 1
Dim T As String * 1
Dim Leddigit(6) As Byte
Dim Tindex As Byte
Dim Leddigitmask As Byte
Dim Leddigitselect As Byte
Dim Ledsegment As Byte
Dim Xdirection As Boolean
Dim Rampupflag As Boolean                                   '
Dim Rampdownflag As Boolean
Dim Halfwayflag As Boolean
Dim Motionflag As Boolean
Dim Abort As Boolean
Dim Jogabort As Boolean
Dim Ramptemp As Integer
Dim Ramploopct As Byte
Dim Disptemp As Byte
Dim Z As Byte
Dim Rustep As Integer
Dim Rdstep As Integer
Dim Axisid As Byte
Dim Jogfast As Double
Dim Jogclkdiv As Word
Dim Jogtemp As Word
Dim Rtemp1 As Double
Dim Rtemp2 As Double
Dim Rtemp3 As Long
Dim Fracdiv As Byte At Rtemp3 Overlay
Dim Clkdiv As Word At Rtemp3 + 1 Overlay
Dim Rpgcount As Word
Dim Rpgtemp As Word

Declare Sub Calcdispdigits()
Declare Sub Displaydigit()
Declare Sub Executemove()
Declare Sub Definecurrentposition()
Declare Sub Definedisplacement()
Declare Sub Definerate()
Declare Sub Defineramprate()
Declare Sub Definestepsperinch()
Declare Sub Reportposition()
Declare Sub Zeroaxis()
Declare Sub Jogplus()
Declare Sub Jogminus()
Declare Sub Calcjograte()
Declare Sub Jog()
Declare Sub Definejogspeed()
Declare Sub Rpgplus()
Declare Sub Rpgminus()
Declare Sub Definerpgstep()
Declare Sub Gotozero()

Const Positive = 1
Const Negative = 0

Const True = 1
Const False = 0

On Compare1a Pulseisr:
Enable Interrupts

Config Portd.4 = Output
Config Portd.6 = Output
Config Portd.3 = Output                                     'Timer 2 Output Capture B
Config Portb.1 = Output
Config Portb.0 = Output
Config Portc.5 = Output
Config Portd.7 = Input
Config Portc.5 = Input
Config Portc.4 = Input
Config Portc.3 = Input
Config Portc.2 = Input

Set Portc.0                                                 ' enable pull ups on Axis ID jumper input pins
Set Portc.1                                                 ' ""
Set Portc.2                                                 ' set pullup on *Execute input
Set Portc.4                                                 ' set pullup on Go to Zero switch input
Set Portc.5                                                 ' set pullup on *Zero Axis switch input
Set Portd.3
Set Portd.7                                                 ' set pullup active on *Fault input

Pulsepin Alias Portb.1
Directionpin Alias Portb.0
Donepin Alias Portd.4
Nfault Alias Pind.7
Executepin Alias Pinc.2
Zeroaxispin Alias Pinc.5
Axisid0 Alias Pinc.0                                        ' port C.0, C.1 are hooked to the Axis ID jumpers
Axisid1 Alias Pinc.1
Gozerosw Alias Pinc.4

' Read the two Axis ID jumpers and set var axisID as follows X=129,Y=130,Z=131, (A=132)                                                '"  "
Axisid = 129
If Axisid0 = 1 Then Axisid = Axisid + 1
If Axisid1 = 1 Then Axisid = Axisid + 2

' provide a 10/2.5/.625 MHz clock for Ramp PWM function
Tccr0a = &B01000011                                         ' fast PWM, top = OC0A
Tccr0b = &B00001001
Compare0a = 0

' set Timer2 for PWM modulation of the 10/2.5/0.625  MHz clock (using external gating)
Tccr2a = &B00000011                                         ' fast PWM, top = OC2A
Tccr2b = &B00001001                                         '  Sys clk/1

' Timer1 is the 16-bit timer that produces the timing for the step pulses
Tccr1a = &B00000010
Tccr1b = &B00011111                                         ' CLK=External, FAST PWM mode 14

' MIC5891 high side switch (LED DIGIT SELECT)  is driven by SPI
' as well as MIC5821 low side switch (LED SEGMENT SINK )
Reset Portb.2
Config Portb.2 = Output                                     ' MIC5891 STROBE
' set up SPI port for MIC5891/5821
Config Spi = Hard , Data Order = Msb , Master = Yes , Polarity = Low , Phase = 0 , , Clockrate = 4
Spiinit

Eicra = &B00000010                                          ' set for falling edge on INT0 line

Config Serialin = Buffered , Size = 100

Echo Off                                                    ' turn off echo chars sent back to host controller

Reset Ucsr0b.3                                              ' turn off the USART transmitter by default (only activated for ? command  )
Config Portd.1 = Input                                      'make TxD pin an input most of the time- unless specifically set for transmit output i.e wired OR of axis board TxD lines

Stepsperinch = 20000
Rpgcount = 20
Currentx = 0
Ramptemp = 10
Leddigitselect = 1
Leddigitmask = 1
Doneflag = False
Abort = False

Jogfast = 5000.0
Call Calcjograte()
Set Donepin                                                 ' make "motion done" flag true

Call Calcdispdigits()                                       ' put up an initial "00.000" display
Motionflag = False                                          ' This flag, when true, indicates a motion command received

'*****************************
' Main program execution loop
'*****************************
Do
 If Executepin = 0 Then Executemove
 If Zeroaxispin = 0 Then Zeroaxis
 If Gozerosw = 0 Then Gotozero
 If Inkey() = Chr(axisid) Then
   ' process command input
    T = Waitkey()                                           'get command mnemonic
    Select Case T
     Case "A" : Jogplus
     Case "B" : Jogminus
     Case "E" : Rpgplus
     Case "F" : Rpgminus
     Case "T" : Abort = True
     Case "C" : Definecurrentposition
     Case "D" : Definedisplacement
     Case "J" : Definejogspeed
     Case "S" : Definerate
     Case "R" : Defineramprate
     Case "P" : Definerpgstep
     Case "X" : Definestepsperinch
     Case "?" : Reportposition
    End Select
 End If
 Call Displaydigit()
 Bitwait Eifr.0 , Set
 Set Eifr.0
 Loop

Sub Rpgplus()
 Reset Donepin
 Set Directionpin
 For Rpgtemp = 1 To Rpgcount
  Set Pulsepin
  Incr Currentx
  Waitus 5
  Reset Pulsepin
  Call Calcdispdigits()
  ' delay for 5 X 2 ms
  For J = 1 To 5
   Call Displaydigit()
   Bitwait Eifr.0 , Set
   Set Eifr.0
  Next
 Next
 Call Calcdispdigits()
 Set Donepin
End Sub

Sub Rpgminus()
 Reset Donepin
 Reset Directionpin
 For Rpgtemp = 1 To Rpgcount
  Set Pulsepin
  Decr Currentx
  Waitus 5
  Reset Pulsepin
  Call Calcdispdigits()
  ' delay for 5 X 2 ms
  For J = 1 To 5
   Call Displaydigit()
   Bitwait Eifr.0 , Set
   Set Eifr.0
  Next
 Next
 Call Calcdispdigits()
 Set Donepin
End Sub

Sub Jogplus
 Set Directionpin
 Xdirection = Positive
 Call Jog()
 End Sub

Sub Jogminus()
 Reset Directionpin
 Xdirection = Negative
 Call Jog()
End Sub

Sub Jog()
 Zz = 0
 Xtemp = 0
 Xsteps = 99999999                                          ' use a large number, as the pulse ISR will be constantly testing to see if the displacment has been covered
 Compare0a = 0                                              ' Generate a 10 MHZ clock for PWM
 Compare2a = 128                                            ' use a 128 point ramp for ramping up the jog rate while switch held down
 Timer1 = 0
 Clkdiv = Jogclkdiv
 Capture1 = Clkdiv
 Compare1a = 10
 Enable Compare1a                                           ' enable interrupt which produces pulses
' ramp up jog rate while switch is pressed
 Tccr2a = &B00110011                                        ' fast PWM, top = OC0A
 Set Eifr.0                                                 ' clear INT0 int flag
 For I = 2 To 128 Step 1
  Compare2b = I
  Call Calcdispdigits()
  For J = 1 To Ramptemp
    Call Displaydigit()
    Bitwait Eifr.0 , Set
    Set Eifr.0
    If Executepin = 1 Then Exit For
  Next
  If Executepin = 1 Then Exit For
 Next
 ' now jogging at fastest rate- continue til jog switch released
 'wait til both jog switches released, as this routine does both directions
 ' stay in a loop, updating the LED display at 500 hz, while switch pressed
 Jogabort = False
 Do
  Call Calcdispdigits()
   Call Displaydigit()
   Bitwait Eifr.0 , Set                                     ' LED refresh rate
   Set Eifr.0
 Loop Until Executepin = 1
 Disable Compare1a
End Sub

Sub Calcjograte()
  Rtemp1 = 2560000000 / Jogfast
  Rtemp2 = Int(rtemp1)
  Rtemp3 = Rtemp2
  ' var fracdiv( LS byte) and clkdiv (2 intermediate bytes) are overlayed on the 32 bit LONG var rtemp3
  Jogclkdiv = Clkdiv                                        ' store this clock div rate for use in jog routines
  Compare0a = 0                                             ' Generate a 10 MHZ clock for PWM
End Sub

Sub Zeroaxis()
 Currentx = 0
 Call Calcdispdigits()
End Sub

Sub Reportposition()
 Set Ucsr0b.3                                               ' turn on the USART transmitter
 Print Currentx;
 Print Chr(13);
 Bitwait Ucsr0a.6 , Set                                     'wait til last character is sent
 Waitms 1
 Reset Ucsr0b.3                                             ' turn off the USART transmitter
 Config Portd.1 = Input                                     're-establish TxD pin as an input
End Sub

Sub Executemove()
 If Motionflag = False Then Exit Sub
 Reset Donepin
 Doneflag = False                                           ' drop Done pin low until move is done
 Zz = 0
 Xtemp = 0
 Rampupflag = False
 Rampdownflag = False
 Halfwayflag = False
 Timer1 = 0
 Enable Compare1a
' ramp up phase
 Compare2a = 64                                             ' set ramp PWM period to 64
 Tccr2a = &B00110011                                        ' fast PWM, top = OC0A
 Set Eifr.0                                                 ' clear INT0 int flag
 For I = 10 To 64 Step 1
  Compare2b = I
  Call Calcdispdigits()
  For J = 1 To Ramptemp
    If Nfault = 0 Then Goto 555
    Call Displaydigit()
    If Halfwayflag = True Then Exit For
    Bitwait Eifr.0 , Set
    Set Eifr.0
  Next
  If Halfwayflag = True Then Exit For
 Next
 If Halfwayflag = True Then
   Ramploopct = I
   Goto Rdphase
 End If
 Rampupflag = True
 Do
  If Nfault = 0 Then Goto 555
  Call Calcdispdigits()
  Call Displaydigit()
  Bitwait Eifr.0 , Set
  Set Eifr.0
 Loop Until Rampupflag = False

 ' Steady speed phase
 Tccr2a = &B00000011                                        ' disconnect OC2B from PD3
 Reset Portd.3                                              ' set the clock enable gate high

 ' proceed at steady speed until we hit rampdown point
 Disptemp = 0
 Do
  If Nfault = 0 Then Goto 555
  Incr Disptemp
  If Disptemp = 50 Then
    Disptemp = 0
   Call Calcdispdigits()
  End If
  Call Displaydigit()
  Bitwait Eifr.0 , Set
  Set Eifr.0
Loop Until Rampdownflag = True

Rdphase:
' Ramp Down Phase
 Tccr2a = &B00110011                                        ' fast PWM, top = OC0A
 Set Eifr.0                                                 ' clear INT0 int flag
 For I = Ramploopct To 10 Step -1
  If Nfault = 0 Then Goto 555
  Compare2b = I
  Call Calcdispdigits()
  For J = 1 To Ramptemp
    Call Displaydigit()
    Bitwait Eifr.0 , Set
    Set Eifr.0
  Next
 Next

Do
 If Nfault = 0 Then Goto 555
 Call Calcdispdigits()
 Call Displaydigit()
Loop Until Doneflag = True
555:
Set Portd.3
Tccr2a = &B00000011                                         ' disconnect OC2B from PD3
Disable Compare1a
Calcdispdigits
Motionflag = False
Set Donepin                                                 ' indicate that the move is done
End Sub

Sub Definecurrentposition()
Input Currentx
Call Calcdispdigits()
End Sub

Sub Definedisplacement()
 Input Xdisplacement
' convert Xdisplacment in mils to steps
 If Xdisplacement < 0 Then
  Reset Directionpin
  Xdirection = Negative
 Else
  Set Directionpin
  Xdirection = Positive
 End If
 Xdisplacement = Abs(xdisplacement)
 Displacetemp = Xdisplacement * Stepsperinch
 Xsteps = Displacetemp / 1000                               'displacement is expressed in inches X 1000
 Halfway = Xsteps
 Shift Halfway , Right , 1                                  'save the halfway point for use by the ramp routines
 Rampstepcount = Xsteps                                     ' need this line so ISR doesn't trigger ramp down phase right off the bat
 Motionflag = True
End Sub

Sub Gotozero()
 Waitms 100
 If Gozerosw = 1 Then Exit Sub
 Xdisplacement = Currentx
' convert Xdisplacement in mils to steps
 If Xdisplacement > 0 Then
  Reset Directionpin
  Xdirection = Negative
 Else
  Set Directionpin
  Xdirection = Positive
 End If
 Xsteps = Abs(xdisplacement)
' Displacetemp = Xdisplacement * Stepsperinch
' Xsteps = Displacetemp / 1000                               'displacement is expressed in inches X 1000
 Halfway = Xsteps
 Shift Halfway , Right , 1                                  'save the halfway point for use by the ramp routines
 Rampstepcount = Xsteps                                     ' need this line so ISR doesn't trigger ramp down phase right off the bat
 Motionflag = True
 Call Executemove
End Sub



Sub Definerate()
 Input Rate
 ' convert step rate in Hz into whole and fractional components of timer1 parameter
 If Rate < 10 Then
  Rtemp1 = 40000000 / Rate                                  ' 156,250 hz X 256
  Rtemp2 = Int(rtemp1)
  Rtemp3 = Rtemp2                                           ' cast the double into a long
  Compare0a = 63                                            ' generate a 625000 Hz clock
  Goto Ratecom
 End If
 If Rate > 10 Then
  Rtemp1 = 160000000 / Rate                                 ' 625 Khz X 256
  Rtemp2 = Int(rtemp1)
  Rtemp3 = Rtemp2                                           ' cast the double into a long
  Compare0a = 15                                            ' generate a 625000 Hz clock
  Goto Ratecom
 End If
 If Rate > 40 Then
  Rtemp1 = 640000000 / Rate                                 ' 2.5 MHZ X 256
  Rtemp2 = Int(rtemp1)
  Rtemp3 = Rtemp2                                           ' cast the double into a long
  Compare0a = 3                                             ' generate a 2.5 MHz clock
  Goto Ratecom
 End If
 If Rate > 155 Then
  Rtemp1 = 2560000000 / Rate
  Rtemp2 = Int(rtemp1)
  Rtemp3 = Rtemp2
  ' var fracdiv( LS byte) and clkdiv (2 intermediate bytes) are overlayed on the 32 bit LONG var rtemp3
  Compare0a = 0                                             ' Generate a 10 MHZ clock for PWM
 End If
Ratecom:
 Ramploopct = 64
 Compare2a = Ramploopct
 Capture1 = Clkdiv
 Compare1a = 10
End Sub

Sub Defineramprate()
 Input Ramptemp
End Sub

Sub Definejogspeed()
 Input Jogfast
 Call Calcjograte
End Sub

Sub Definestepsperinch()
 Input Stepsperinch
End Sub

Sub Definerpgstep()
 Input Rpgcount
End Sub

Sub Calcdispdigits()                                        ' takes 250 us
 Displayvalue = Currentx * 1000
 Displayvalue = Displayvalue / Stepsperinch
 Dstring = Str(displayvalue)
 Strtemp = Format(dstring , "+00.000")
 S2temp = Mid(strtemp , 1 , 1)
 If S2temp = "+" Then
   Leddigit(1) = 0
 Else
   Leddigit(1) = 16
 End If
 S2temp = Mid(strtemp , 2 , 1)
 Tindex = Asc(s2temp)
 Tindex = Tindex - &H30
 Leddigit(2) = Lookup(tindex , Segmenttable)
 S2temp = Mid(strtemp , 3 , 1)
 Tindex = Asc(s2temp)
 Tindex = Tindex - &H30
 Z = Lookup(tindex , Segmenttable)
 Z = Z Or 1                                                 ' set the fixed decimal place
 Leddigit(3) = Z
 S2temp = Mid(strtemp , 5 , 1)
 Tindex = Asc(s2temp)
 Tindex = Tindex - &H30
 Leddigit(4) = Lookup(tindex , Segmenttable)
 S2temp = Mid(strtemp , 6 , 1)
 Tindex = Asc(s2temp)
 Tindex = Tindex - &H30
 Leddigit(5) = Lookup(tindex , Segmenttable)
 S2temp = Mid(strtemp , 7 , 1)
 Tindex = Asc(s2temp)
 Tindex = Tindex - &H30
 Leddigit(6) = Lookup(tindex , Segmenttable)
End Sub

Sub Displaydigit()
 Ledsegment = Leddigit(leddigitselect)
 Spiout Ledsegment , 1
 Spiout Leddigitmask , 1
 Leddigitselect = Leddigitselect Mod 6
 Incr Leddigitselect
 Set Portb.2
 nop
 nop
 Reset Portb.2
 Shift Leddigitmask , Left , 1
 If Leddigitmask = 64 Then Leddigitmask = 1
End Sub

Pulseisr:
  If Nfault = 0 Then Goto 999
  Set Pulsepin
  Incr Zz
  If Zz >= Fracdiv Then
    Capture1 = Clkdiv - 1
  Else
    Capture1 = Clkdiv
  End If
  Incr Xtemp
  If Xdirection = Positive Then
    Incr Currentx
  Else
    Decr Currentx
  End If
  If Xtemp >= Xsteps Then
    Disable Compare1a
    Set Donepin
    Doneflag = True
  End If
  If Rampupflag = True Then
    Rampstepcount = Xsteps - Xtemp
    Rampupflag = False
  End If
  If Xtemp >= Rampstepcount Then
   Rampdownflag = True
  End If
  If Xtemp = Halfway Then
   Halfwayflag = True
  End If
  Reset Pulsepin
  999:
 Return

' lookup table converts numbers 0-9 into active high 7-segment drive needed for MIC5821
' 10th entry blanks the LED by sending all lows
' 11th entry is lower case "n"
'12th entry is lower case "d"
'13th entry is "E"
'14th entry is "r"

Segmenttable:
Data 238 , 36 , 122 , 118 , 180 , 214 , 222 , 100 , 254 , 244 , 28 , 62 , 218 , 24